/******************************************************************************
*******************************************************************************

	Space Impakto DS
	relminator
	http://rel.betterwebber.com


	Cobject class


*******************************************************************************
******************************************************************************/


#include <nds.h>
#include <assert.h>
	



#include "Csprite.h"

#ifndef Cobject__H
#define Cobject__H

// enums for where to store the sprites GFX
enum E_gfx_location
{
	E_GFX_VRAM = 0,
	E_GFX_RAM
};

/*	Base class for our game objects
	Probable derived classes:
		viper
		enemies
		bosses
		bullets
		shots
		homings
*/

class Cobject
{
	public:
	
	Cobject();
	Cobject(OamState *_oam,u8 *_gfx, u32 _width, u32 _height, SpriteSize _size, u32 _numframes, E_gfx_location _gfx_location);
	~Cobject();
	
	void init(OamState *_oam,u8 *_gfx, u32 _width, u32 _height, SpriteSize _size, u32 _numframes, E_gfx_location _gfx_location);
	void update_oam();
	
	
	OamState 		*oam;
	s32				active;
	s32 			x;
	s32 			y;
	s32 			dx;
	s32 			dy;
	s32				frame;
	s32				num_frames;
	s32				anim_counter;
	s32				anim_delay;
	E_gfx_location	gfx_location;		// Vram or ram
	u8				*gfx_start_offset;	// offset from RAM gfx of object is located (not needed in VRAM type)
	u32				tile_offset;		// size of tiles to DMA copy per frame for RAM type
	Csprite 		*sprites;			// should be done with new and delete so that 6 = num_frames
};



#endif // Cobject