/******************************************************************************
*******************************************************************************

	Space Impakto DS
	relminator
	http://rel.betterwebber.com


	Coption class


*******************************************************************************
******************************************************************************/


#include "cearn_atan.h"
#include "Csprite.h"
#include "Cobject.h"
#include "Cbullet.h"
#include "Coption.h"



/******************************************************************************


******************************************************************************/
Coption::Coption()
{

	angle = 0;
	radius_x = 30;
	radius_y = 25;

}

/******************************************************************************


******************************************************************************/
void Coption::start_shots(s32 start_x, s32 start_y, s32 target_x, s32 target_y)
{
	
	for(int i=0; i<MAX_OPTION_BULLETS; i++)
	{
		if (!shots[i].active)
		{
			shots[i].active = true;
			shots[i].x = start_x << 12;
			shots[i].y = start_y << 12;
			
			u32 dx = target_x - start_x;
			u32 dy = target_y - start_y;
			
			u32 angle = atan2Lookup(dx, dy);
			
			shots[i].dx = cosLerp(angle) * 6;
			shots[i].dy = sinLerp(angle) * 6;
			shots[i].frame = 0;			
			break;
		}
	}

}

/******************************************************************************


******************************************************************************/
void Coption::do_shots()
{

	// todo: shots are in fixed point format
	// needs to change bullet.update function
	
	s32 _x;
	s32 _y;
	
	for(int i=0; i<MAX_OPTION_BULLETS; i++)
	{
		if (shots[i].active)
		{		
			// animate 
			if ( shots[i].anim_counter >= shots[i].anim_delay)
			{
				shots[i].frame++;
				if ( shots[i].frame >= shots[i].num_frames)
					shots[i].frame = 0;
				
				shots[i].anim_counter = -1;
			}

			// inc counter
			shots[i].anim_counter++;
			
			
			shots[i].x += shots[i].dx;
			shots[i].y += shots[i].dy;
	
			_x = shots[i].x >> 12;
			_y = shots[i].y >> 12;
	
			
			if ( (_x > 272) || (_x < -16) || (_y > 212) || (_y < -16) )
				shots[i].active = false;
			else
				shots[i].update();
			
		}
	}
}

/******************************************************************************


******************************************************************************/
void Coption::update(s32 cx, s32 cy)
{

	
		// animate 
	if ( anim_counter >= anim_delay)
	{
		frame++;
		if ( frame >= num_frames)
			frame = 0;
		
		anim_counter = -1;
	}

	// inc counter
	anim_counter++;
		
	angle += 256; 
	x = cx + ( (cosLerp(angle) *  radius_x) >> 12);
	y = cy + ( (sinLerp(angle) *  radius_y) >> 12);

	// copy bullet pos to oam compatible sprite struct
	sprites[frame].x = x;
	sprites[frame].y = y; 
	
	update_oam();
	
}

/******************************************************************************


******************************************************************************/
void Coption::initialize(u8 *option_gfx, u8 *option_shot_gfx)
{

	int width = 16;
	int height = 16;
	SpriteSize size = SpriteSize_16x16; 	
	
	init(&oamMain, option_gfx, width, height, size, 4, E_GFX_VRAM);
	
	
	width = 8;
	height = 8;
	size = SpriteSize_8x8; 	
	
	for(int i=0; i<MAX_OPTION_BULLETS; i++)
	{
		shots[i].init(&oamMain, option_shot_gfx, width, height, size, 4, E_GFX_VRAM);
		shots[i].active = false;
	}
}